DIR_INST="${DIR_INST:-$HOME/nsolid}"

#######
# set fonts for help
#######
NORM=$(tput sgr0)
BOLD=$(tput bold)

#-------------------------------------------------------------------------------
# unpack
#-------------------------------------------------------------------------------

echo ""
DIR_INST=$(readlink -f ${DIR_INST})
echo "unpacking tarballs into ${DIR_INST}"

mkdir -p ${DIR_INST}
mkdir -p ${DIR_INST}/nsolid-dubnium
mkdir -p ${DIR_INST}/nsolid-erbium
mkdir -p ${DIR_INST}/console

rm -f    ${DIR_INST}/nsolid
rm -rf   ${DIR_INST}/nsolid-dubnium/*
rm -rf   ${DIR_INST}/nsolid-erbium/*
rm -rf   ${DIR_INST}/console/*

tar --strip-components 1 -zxf ./nsolid-*-dubnium*linux*.tar.gz -C ${DIR_INST}/nsolid-dubnium
tar --strip-components 1 -zxf ./nsolid-*-erbium*linux*.tar.gz -C ${DIR_INST}/nsolid-erbium
tar --strip-components 1 -zxf ./nsolid-console-*linux*.tar.gz -C ${DIR_INST}/console

# link /nsolid to /nsolid-dubnium
ln -s ${DIR_INST}/nsolid-dubnium ${DIR_INST}/nsolid

#-------------------------------------------------------------------------------
# write launch scripts
#-------------------------------------------------------------------------------

#--------------------------------------
echo "writing launch script"

cat > ${DIR_INST}/nsolid-console.sh << END_CONSOLE_SH
NSOLID_PATH="$DIR_INST/nsolid"
CONSOLE_LOG="/tmp/nsolid-console.log"

trap 'echo "Shutting down nsolid-console"; kill %1' SIGINT

#######
# setting log files and data dir
######
touch \$CONSOLE_LOG
chmod 0666 \$CONSOLE_LOG

#######
# starting processes
#######
NODE_ENV=production ${DIR_INST}/nsolid/bin/nsolid ${DIR_INST}/console/nsolid-console 2>&1 | tee \$CONSOLE_LOG
END_CONSOLE_SH

chmod +x ${DIR_INST}/nsolid-console.sh
