'use strict'

const agentManager = require('../agent-manager')
const commandDispatcher = require('../command-dispatcher')
const assetManager = require('../asset-manager')
const diskAssetManager = require('../disk-asset-manager')
const vulnManager = require('../vuln-manager')
const providerManager = require('../provider')
const fieldManager = require('../field-manager')
const eventManager = require('../event-manager')
const actionManager = require('../action-manager')
const packageManager = require('../package-manager')

module.exports.register = function register (Context) {
  Context.agentManager = agentManager.create(Context)
  Context.commandDispatcher = commandDispatcher.create(Context)
  Context.assetManager = assetManager.create(Context)
  Context.fieldManager = fieldManager.create(Context)
  Context.eventManager = eventManager.create(Context)
  Context.packageManager = packageManager.create(Context)
}

module.exports.registerSettingsDependant = function rSD (Context, cb) {
  // These depend on settings being available before they can be used.
  Context.diskAssetManager = diskAssetManager.create(Context)
  Context.vulnManager = vulnManager.create(Context)
  providerManager.create(Context, (err, provider) => {
    if (err) return setImmediate(cb, err)
    Context.provider = provider
    Context.actionManager = actionManager.create(Context)
    setImmediate(cb)
  })
}
