'use strict'

exports.handleRequest = handleRequest

const util = require('../../util')
const Logger = util.getLogger(__dirname, __filename)
const httpUtils = require('../http-utils')

// Handle the HTTP request
function handleRequest (req, res) {
  const context = req.nsConsole.context
  const eventStream = req.nsConsole.eventStream
  const qData = req.nsConsole.qData
  const diskAssetManager = context.diskAssetManager

  if (qData.start == null) qData.start = 0

  Logger.debug('gathering assets')

  if (diskAssetManager == null) {
    res.status(501)
    Logger.error('diskAssetManager not initialized')
    return res.send({ error: 'Server error' })
  }

  const assets = diskAssetManager.query(qData)
  for (let asset of assets) {
    eventStream.writeData(httpUtils.normalizeAsset(asset))
  }

  eventStream.close()
}
