'use strict'

const { errors } = require('../../errors')

exports.handleRequest = handleRequest

// Handle the HTTP request
function handleRequest (req, res) {
  const context = req.nsConsole.context

  context.provider.sessionKeys((err, keys) => {
    if (err) {
      if (err instanceof errors.TermsNotAccepted) {
        res.status(400).send({ code: 'User::TermsNotAccepted' })
      } else {
        res.status(404).send({ error: 'Keys not found' })
      }
      return
    }
    res.send({ keys })
  })
}
