'use strict'

exports.handleRequest = handleRequest

// Handle the HTTP request
function handleRequest (req, res) {
  const context = req.nsConsole.context
  const qData = req.nsConsole.qData

  // get the vuln
  const vuln = context.vulnManager.getVulnById(qData.id)
  if (vuln == null) {
    res.status(404)
    return res.send({ error: `vulnerability ${qData.id} not found` })
  }

  // if no metadata, something went wrong
  if (vuln.nsolidMetaData == null) {
    res.status(500)
    return res.send({ error: `no metadata found for vulnerability ${qData.id}` })
  }

  // return the metadata
  res.status(200)
  res.send(vuln.nsolidMetaData)
}
