'use strict'

const util = require('../../util')
const Logger = util.getLogger(__dirname, __filename)

exports.handleRequest = handleRequest

// Handle the HTTP request
function handleRequest (req, res) {
  const { context } = req.nsConsole
  const { consoleURL } = context.config.notification
  const { email } = req.body
  if (email) {
    context.provider.loginGateway(email, consoleURL, (err, result) => {
      if (err) {
        Logger.warn(`No user found from login gateway: ${err.message}`)
        // send {} to show 'no user found' message in UI
        res.send({})
      } else {
        // samlSp: saml service provider
        res.cookie('samlSp', 'nsolid')
        res.cookie('samlEmail', email)
        res.cookie('samlOrigin', consoleURL)
        res.send(result)
      }
    })
  } else {
    Logger.error('Invalid login method requested')
    res.status(400).send({ message: 'Invalid login method' })
  }
}
