'use strict'

exports.handleRequest = handleRequest

const simpleCommand = require('../simple-command')

// Handle the HTTP request
function handleRequest (req, res) {
  const context = req.nsConsole.context
  const qData = req.nsConsole.qData

  simpleCommand.run(context, null, res, qData, {
    command: 'startup_times',
    transformer: getTransformer(context)
  })
}

function getTransformer (context) {
  return function transformer (body, cb) {
    const agent = context.agentManager.byId(body.id)

    if (!agent) {
      return cb(null, body)
    }

    if (agent.info) {
      body.tags = agent.info.tags
      body.app = agent.info.app
      body.hostname = agent.info.hostname
    }

    cb(null, body)
  }
}
