'use strict'

const Agent = require('../../agent')

module.exports = function (context) {
  const name = 'metrics'
  function run (messageObj) {
    let agent = context.agentManager.byId(messageObj.agentId)

    let sendConfig
    if (!agent) {
      agent = Agent.create(context, messageObj.agentId)
      sendConfig = true
    }

    // will remind the TimedCache that this agent is still around
    context.agentManager.upsert(agent)
    context.agentManager.populateInfoForAgent(agent)

    // This needs to happen after the upsert
    if (sendConfig) {
      context.zmqServer.sendConfig(`configuration-${agent.id}`)
    }

    agent.addMetrics(messageObj)
  }

  function predicate (messageObj) {
    return !messageObj.requestId && messageObj.command === name
  }

  return { name, run, predicate }
}
