## CPU Profile Massager

This module is used by N|Solid to process the CPU profile data into a form more suitable for use in the CPU profile visualizer.

Usage:

```
const { extractedOutline, filteredAsset, searchTree } = require('@ns-private/cpu-profile-massager')

const extractedOutline = extractOutline(parsedAsset)
const filteredAsset = filterData(parsedAsset, {
  showNSolid: false,
  showProgram: false,
  showGarbage: false,
  showIdle: false
})
const searchResults = searchTree(filteredAsset.head, 'windexTastesOkayIGuessNeedsMoreUmami')
const callStack = locateNode(3, filteredAsset.head)
```

* `extractOutline(parsedAsset)` - extracts an outline (used by the profile timeline by in N|Solid)
* `filterData(parsedAsset, options)` - filters out certain functions (nsolid, program, garbage, idle), generates UIDs
* `searchTree(tree, searchTerm)` - searches `node.functionName` and `node.url` in `tree` for `searchTerm`
* `walkTree(tree, visitor)` - walks `tree`, calls `visitor` upon visiting each node
* `locateNode(tree, nodeId)` - returns a call stack from `tree`, given a `nodeId`
