'use strict'

const walkTree = require('./walk-tree')

const locateNode = (tree, nodeId) => {
  let highlightedNode
  if (tree === null) { return }
  walkTree(tree, (node, parent) => {
    if (node.id === nodeId) {
      highlightedNode = node
      return false // terminate early when node is found
    }
  })

  let parent = highlightedNode
  let stack = [highlightedNode]

  while (parent && parent.parent) {
    parent = parent.parent
    stack.push(parent)
  }
  return stack
}

module.exports = locateNode
