'use strict'

const walkTree = require('./walk-tree')

const searchTree = (tree, searchTerm) => {
  if (searchTerm === '') { return [] }

  let results = []
  walkTree(tree, node => {
    if (node.functionName.indexOf(searchTerm) > -1 || node.url.indexOf(searchTerm) > -1) {
      results.push({
        id: node.id,
        codeType: node.codeType,
        functionName: node.functionName,
        hitCount: node.hitCount,
        selfTime: node.selfTime,
        short: node.short,
        totalHitCount: node.totalHitCount,
        totalTime: node.totalTime,
        url: node.url,
        lineNumber: node.lineNumber
      })
    }
  })
  return results
}

module.exports = searchTree
