'use strict'

const walkTree = (tree, visitor) => {
  const recurse = (node, parent) => {
    if (visitor(node, parent) === false) { return false }
    const children = node.children
    if (!children) { return }
    for (let i = 0; i < children.length; i++) {
      recurse(children[i], node)
    }
  }
  recurse(tree, null)
}

module.exports = walkTree
