'use strict'

const tape = require('tape')
const walkTree = require('../src/walk-tree')

tape('walkTree', t => {
  const root = {
    children: [{
      id: 2,
      hasKids: true,
      children: null
    }, {
      id: 3,
      hasKids: false,
      children: null
    }],
    id: 1,
    hasKids: true
  }

  let totalIdSum = 0
  const visitor = (node, parent) => {
    totalIdSum += node.id
    return node.hasKids && parent
  }

  walkTree(root, visitor)

  t.equals(6, totalIdSum, 'traversed tree')
  t.end()
})
