import { NullableMappedPosition, Position } from 'source-map';
import { CpuProfileNode } from './CpuProfile';
export declare class SourceInfo implements Position {
    url: string;
    functionName: string | null;
    line: number;
    column: number;
    static fromNode(node: CpuProfileNode): SourceInfo;
    static fromPosition(url: string, pos: NullableMappedPosition): SourceInfo;
    constructor(url: string, functionName: string | null, line: number, column?: number);
    clone(): SourceInfo;
    withColumn(column: number): SourceInfo;
}
