"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class SourceInfo {
    constructor(url, functionName, line, column = 0) {
        this.url = url;
        this.functionName = functionName;
        this.line = line;
        this.column = column;
    }
    static fromNode(node) {
        return new SourceInfo(node.url, node.functionName || null, node.lineNumber);
    }
    static fromPosition(url, pos) {
        return new SourceInfo(url, pos.name || null, pos.line || 0, pos.column || 0);
    }
    clone() {
        return new SourceInfo(this.url, this.functionName, this.line, this.column);
    }
    withColumn(column) {
        const cloned = this.clone();
        cloned.column = column;
        return cloned;
    }
}
exports.SourceInfo = SourceInfo;
//# sourceMappingURL=SourceInfo.js.map