import { CpuProfileNode } from './CpuProfile';
import { SourceInfo } from './SourceInfo';
import { ResolveSourcemapFailureReason, SourcemapResolver } from './SourcemapResolver';
export declare class SourceInfoMapError {
    failureReason: ResolveSourcemapFailureReason;
    errorMessage: string;
    constructor(failureReason: ResolveSourcemapFailureReason, errorMessage: string);
}
export declare class SourceInfoMapResult {
    sourceInfo: SourceInfo | null;
    failureReason: ResolveSourcemapFailureReason | null;
    errorMessage: string | null;
    readonly hasError: boolean;
    readonly isEmpty: boolean;
    static failureResult(reason: ResolveSourcemapFailureReason, errorMessage: string): SourceInfoMapResult;
    static success(sourceInfo: SourceInfo): SourceInfoMapResult;
    static readonly empty: SourceInfoMapResult;
    constructor(sourceInfo: SourceInfo | null, failureReason?: ResolveSourcemapFailureReason | null, errorMessage?: string | null);
}
export declare class SourceInfoMapper {
    private _sourcemapResolver;
    private _maxColumnTries;
    static forAdjacentFile(maxColumnTries?: number): SourceInfoMapper;
    static forRemoteFile(endpoint: string, zipMapFile: string, generateRequestInfo?: (fileUrl: string, zipFile: string | null) => RequestInit, maxColumnTries?: number): SourceInfoMapper;
    static forResolver(sourcemapResolver: SourcemapResolver, maxColumnTries?: number): SourceInfoMapper;
    private constructor();
    map(nodes: CpuProfileNode[]): Promise<SourceInfoMapError[]>;
    private _map;
}
