import { RawSourceMap } from 'source-map';
import { SourceInfo } from './SourceInfo';
export declare class SourcemapData implements RawSourceMap {
    version: number;
    names: string[];
    file: string;
    sourceRoot: string;
    sources: string[];
    mappings: string;
    sourcesContent?: string[];
    constructor(v3map: RawSourceMap, includeContents?: boolean);
}
export declare class Sourcemap {
    static fromRawSourcemapJSON(json: string): Sourcemap;
    static fromRawSourcemap(map: RawSourceMap): Sourcemap;
    private readonly _sourcemapData;
    private _consumer?;
    constructor(map: RawSourceMap, includeContents?: boolean);
    readonly sourcemapData: SourcemapData;
    originalPosition(sourceInfo: SourceInfo): Promise<SourceInfo>;
}
