import { Sourcemap } from './Sourcemap';
export declare const enum ResolveSourcemapFailureReason {
    projectInaccessible = 0,
    unknown = 1
}
export declare class ResolveSourcemapResult {
    sourcemap: Sourcemap | null;
    failureReason: ResolveSourcemapFailureReason | null;
    errorMessage: string | null;
    static readonly empty: ResolveSourcemapResult;
    readonly hasError: boolean;
    readonly isEmpty: boolean;
    static failureResult(reason: ResolveSourcemapFailureReason, errorMessage: string): ResolveSourcemapResult;
    constructor(sourcemap: Sourcemap | null, failureReason?: ResolveSourcemapFailureReason | null, errorMessage?: string | null);
}
export declare abstract class SourcemapResolver {
    protected _cache: boolean;
    constructor(_cache?: boolean);
    abstract resolveSourcemap(url: string): Promise<ResolveSourcemapResult>;
}
