import { JSZipObject } from 'jszip';
import { ResolveSourcemapResult, SourcemapResolver } from './SourcemapResolver';
export declare type MapFileFromPath = (path: string) => string;
export declare class ZipMapFileResolver extends SourcemapResolver {
    private _zipFilePath;
    private _mapFileFromPath;
    static adjacentMapFileFromPath: MapFileFromPath;
    static cachedInstance(zipFilePath: string, mapFileFromPath?: MapFileFromPath): ZipMapFileResolver;
    static removeFromCache(zipFilePath: string): void;
    private static _resolverCache;
    private _loadedZip?;
    constructor(_zipFilePath: string, _mapFileFromPath?: MapFileFromPath);
    resolveSourcemap(url: string): Promise<ResolveSourcemapResult>;
    protected _loadZip(): Promise<void>;
    protected _matchUrl(url: string): JSZipObject | null;
}
