"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const util_1 = require("util");
const access = util_1.promisify(fs_1.default.access);
const stat = util_1.promisify(fs_1.default.stat);
exports.readFile = util_1.promisify(fs_1.default.readFile);
async function canRead(p) {
    try {
        await access(p, fs_1.default.constants.R_OK);
        return true;
    }
    catch (err) {
        return false;
    }
}
exports.canRead = canRead;
async function isAccessibleDirectory(fullPath) {
    try {
        const info = await stat(fullPath);
        return info.isDirectory();
    }
    catch (err) {
        return false;
    }
}
exports.isAccessibleDirectory = isAccessibleDirectory;
//# sourceMappingURL=fs-utils.js.map