"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const SourceInfoMapper_1 = require("./SourceInfoMapper");
const profileJSONPath = `${process.cwd()}/samples/typescript/profiles/mapfile.json`;
const profileJSON = JSON.parse(fs_1.default.readFileSync(profileJSONPath, 'utf8'));
const profile = profileJSON;
const nodes = profile.head.children;
const mapper = SourceInfoMapper_1.SourceInfoMapper.forAdjacentFile();
function dumpUrls(mappedNodes, search) {
    for (const node of mappedNodes) {
        if (node.url != null && node.url.includes(search)) {
            console.log(node.url);
        }
        if (node.children != null && node.children.length > 0) {
            dumpUrls(node.children, search);
        }
    }
}
async function run() {
    try {
        await mapper.map(nodes);
        const mappedJSON = JSON.stringify(nodes, null, 2);
        dumpUrls(nodes, 'cpu-');
        fs_1.default.writeFileSync(`${__dirname}/../samples/typescript/profiles/mapfile.mapped.json`, mappedJSON);
    }
    catch (err) {
        console.error(err);
    }
}
run();
//# sourceMappingURL=main.js.map