"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ZipMapFileResolver_1 = require("./ZipMapFileResolver");
const zipFile = `${process.cwd()}/samples/typescript/dist.zip`;
const zipMapResolver = ZipMapFileResolver_1.ZipMapFileResolver.cachedInstance(zipFile);
async function run() {
    try {
        const result = await zipMapResolver.resolveSourcemap(
        // tslint:disable-next-line:max-line-length
        `${process.cwd()}/samples/typescript/dist/lib/cpu-encrypt.js`);
        if (result.hasError) {
            console.error(`${result.failureReason} ${result.errorMessage}`);
        }
        else {
            console.log(result.sourcemap.sourcemapData);
        }
    }
    catch (err) {
        console.error(err);
    }
}
run();
//# sourceMappingURL=main.zip.js.map