import { Request, Response } from 'express'
import express from 'express'
import { AdjacentMapFileResolver } from 'sm-profile-resolver'

const PORT = 9002
const app = express()

const resolver = new AdjacentMapFileResolver()

app
  .post('/sourcemap', express.json(), async (req: Request, res: Response) => {
    const { fileUrl } = req.body
    if (fileUrl == null) {
       res
        .status(422)
        .json({ result: null, error: 'Missing fileUrl in body' })
    } else {
      const sourcemap = await resolver.resolveSourcemap(fileUrl)
      res.json({ result: sourcemap && sourcemap.sourcemapData, error: null })
    }
  })
  .listen(PORT, () => console.error(`Listening on localhost:${PORT}`))
