import fs from 'fs'
import { promisify } from 'util'
const access = promisify(fs.access)
const stat = promisify(fs.stat)
export const readFile = promisify(fs.readFile)

export async function canRead(p: string): Promise<boolean> {
  try {
    await access(p, fs.constants.R_OK)
    return true
  } catch (err) {
    return false
  }
}

export async function isAccessibleDirectory(fullPath: string):
  Promise<boolean> {
  try {
    const info = await stat(fullPath)
    return info.isDirectory()
  } catch (err) {
    return false
  }
}
