import { ZipMapFileResolver } from './ZipMapFileResolver'

const zipFile = `${process.cwd()}/samples/typescript/dist.zip`
const zipMapResolver = ZipMapFileResolver.cachedInstance(zipFile)

async function run() {
  try {
    const result = await zipMapResolver.resolveSourcemap(
      // tslint:disable-next-line:max-line-length
      `${process.cwd()}/samples/typescript/dist/lib/cpu-encrypt.js`
    )
    if (result.hasError) {
      console.error(`${result.failureReason} ${result.errorMessage}`)
    } else {
      console.log(result.sourcemap!.sourcemapData)
    }
  } catch (err) {
    console.error(err)
  }
}
run()