'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = Partition;

function Partition() {
  var sort = function sort(a, b) {
    return b.value - a.value;
  };
  var children = function children(d) {
    return d.children;
  };
  var value = function value(d) {
    return d.value;
  };

  partition.nodes = partition;
  partition.sort = function () {
    for (var _len = arguments.length, x = Array(_len), _key = 0; _key < _len; _key++) {
      x[_key] = arguments[_key];
    }

    return x.length ? (sort = x[0], partition) : partition;
  };
  partition.value = function () {
    for (var _len2 = arguments.length, x = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      x[_key2] = arguments[_key2];
    }

    return x.length ? (value = x[0], partition) : partition;
  };
  partition.children = function () {
    for (var _len3 = arguments.length, x = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      x[_key3] = arguments[_key3];
    }

    return x.length ? (children = x[0], partition) : partition;
  };

  return partition;

  function partition(root) {
    var stack = [root];
    var nodes = [];
    var child;
    var node;

    root.parent = 0;
    root.depth = 0;

    while (typeof (node = stack.pop()) !== 'undefined') {
      nodes.push(node);

      var childs = children.call(partition, node, node.depth);
      var n = childs && childs.length;
      if (n) {
        while (--n >= 0) {
          stack.push(child = childs[n]);
          child.depth = node.depth + 1;
          child.parent = node;
        }
      }

      node.children = childs || null;
      node.value = +value.call(partition, node, node.depth) || 0;
    }

    visitAfter(root, function (node) {
      var childs = node.children;
      var parent = node.parent;
      if (sort && childs) childs.sort(sort);
      if (value && parent) parent.value += node.value;
    });

    return nodes;
  }
}

function visitAfter(node, callback) {
  var nodes = [node];
  var nodes2 = [];
  while ((node = nodes.pop()) != null) {
    var children;
    var n;

    nodes2.push(node);

    if ((children = node.children) && (n = children.length)) {
      var i = -1;
      while (++i < n) nodes.push(children[i]);
    }
  }
  while ((node = nodes2.pop()) != null) {
    callback(node);
  }
}
module.exports = exports['default'];
